/*======================================================================*/
/* RTC.H: Interface to Manipulate the MC146818 Processor (real time	*/
/*         clock and battery backup RAM)	                        */
/*                                                                      */
/* Author: Guto								*/
/*                                                                      */
/* Created: 97/05/20							*/
/* Last Updated: 97/05/20                     				*/
/*======================================================================*/

/*======================================================================*/
/* CONSTANTS								*/
/*======================================================================*/
/* I/O PORTS */
#define RTC_ADDRESS_PORT	(0x70)
#define RTC_DATA_PORT		(0x71)

/* BACKUP BATTERY RAM ADDRESSES */
#define CMOS_MAIN_MEMORY_LSB		(0x15)
#define CMOS_MAIN_MEMORY_MSB		(0x16)
#define CMOS_EXPANDED_MEMORY_LSB	(0x17)
#define CMOS_EXPANDED_MEMORY_MSB	(0x18)

/*======================================================================*/
/* PROTOTYPES								*/
/*======================================================================*/
int get_real_time(void);
int get_memory_size(void);

