#ifndef __parallel_device_h
#define __parallel_device_h

#include <device.h>
#include "common.h"

__BEGIN_SYS
__BEGIN_IMP

/**
 * Parallel_Device
 *
 * A device connected to a parallel bus 
 * 
 * The parallel bus is an abstraction that encapsulates
 * the software bus specified in IEEE1284.3 standard 
 */

typedef unsigned char BYTE;

class Parallel_Device: private Device_Common
{
public:
    Parallel_Device();
    ~Parallel_Device();

    // methods

    static int init(System_Info *si);

protected:
    // data
};

__END_IMP
__END_SYS

#endif

