#ifndef __exclusive_thread_h
#define __exclusive_thread_h

#include <thread.h>
#include "common.h"
#include <pthread.h>

__BEGIN_SYS
__BEGIN_IMP

class Exclusive_Thread: protected Thread_Common
{
    typedef Traits<Exclusive_Thread> traits;

protected:
  Exclusive_Thread() {}

public:
    Exclusive_Thread(const Thread_Self &);
    ~Exclusive_Thread();

    void stat(Thread_Status * status);

    static void exit(int exit_status = 0);

    static int init(System_Info * si);

protected:
    pthread_t thread;
};

__END_IMP
__END_SYS

#endif

